import type { NgxFileUploadRequest } from './upload.request';
export declare class NgxFileUploadQueue {
    private active;
    private queuedUploads;
    private concurrentCount;
    private observedUploads;
    private queue$;
    constructor();
    set concurrent(count: number);
    register(upload: NgxFileUploadRequest): void;
    /**
     * register to upload change
     */
    private registerUploadChange;
    private writeToQueue;
    private runRequest;
    /**
     * requests gets completed, this means request is pending or was progressing and the user
     * cancel request, remove it or even destroys them
     */
    private requestCompleted;
    /**
     * checks upload is in queue
     */
    private isInUploadQueue;
    /**
     * remove upload request from queued uploads
     */
    private removeFromQueue;
    private startNextInQueue;
}
