import type { HttpErrorResponse, HttpResponse } from '@angular/common/http';
import { NgxFileUploadState, type INgxFileUploadFile, type INgxFileUploadRequestData, type INgxFileUploadRequestModel, type NgxFileUploadValidationErrors } from '../../api';
import type { NgxFileUploadFile } from './upload.file';
/**
 * Represents an upload request, and store the data inside
 */
export declare class NgxFileUploadRequestModel implements INgxFileUploadRequestModel {
    private readonly filesToUpload;
    private errors;
    constructor(filesToUpload: INgxFileUploadFile | INgxFileUploadFile[]);
    get files(): NgxFileUploadFile[];
    get name(): string[];
    get size(): number;
    get validationErrors(): NgxFileUploadValidationErrors | null;
    response: HttpResponse<unknown> | HttpErrorResponse | null;
    state: NgxFileUploadState;
    uploaded: number;
    progress: number;
    hasError: boolean;
    toJson(): INgxFileUploadRequestData;
}
